﻿Partial Public Class StickyComponentTestPage

    Private Shared _Count As Integer = 0
    Private _Index As Integer
    Public Sub New()
        Debug.Print("---------------------------------------------------------------")
        _Count += 1
        _Index = _Count
        Debug.Print("{0} {1} Constructed", Me.GetType.Name, _Index)
        InitializeComponent()
    End Sub
    Protected Overrides Sub Finalize()
        Debug.Print("{0} {1} Finalized", Me.GetType.Name, _Index)
        MyBase.Finalize()
    End Sub

    Private Sub Page_Initialized(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Initialized
        Debug.Print("{0} {1} Initialized", Me.GetType.Name, _Index)
    End Sub

    Private Sub Page_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs) Handles Me.Loaded
        Debug.Print("{0} {1} Loaded", Me.GetType.Name, _Index)
    End Sub

    Private Sub Page_Unloaded(ByVal sender As Object, ByVal e As RoutedEventArgs) Handles Me.Unloaded
        Debug.Print("{0} {1} Unloaded", Me.GetType.Name, _Index)
    End Sub

    Private Sub DetachButton_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        StickyTestComponent.SetComponent(Me, Nothing)
        StickyTestComponent.SetComponent(TestPage, Nothing)
        TestStickyPatterns.SetComponent(TestEventPatternsButton, Nothing)
    End Sub

    Private Sub AttachButton_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        StickyTestComponent.SetComponent(Me, Me.FindResource("teststicky"))
        StickyTestComponent.SetComponent(TestPage, Me.FindResource("test2"))
        TestStickyPatterns.SetComponent(TestEventPatternsButton, Me.FindResource("UseEvents"))
    End Sub
End Class
