﻿Imports WPFGlue.Framework

Namespace Commanding
    Public MustInherit Class CommandBase
        Inherits Freezable
        Implements IStickyComponent

        Private ReadOnly Property _Mode As Framework.AttachMode Implements Framework.IStickyComponent.Mode
            Get
                Return AttachMode.Immediate
            End Get
        End Property

        Private Sub _OnAttach(ByVal base As Object, ByVal e As System.EventArgs) Implements Framework.IStickyComponent.OnAttach
            Attach(base)
        End Sub

        Private Sub _OnDetach(ByVal base As Object, ByVal e As System.EventArgs) Implements Framework.IStickyComponent.OnDetach
            Detach(base)
        End Sub

        Protected MustOverride Sub Attach(ByVal base As Object)

        Protected MustOverride Sub Detach(ByVal base As Object)

        Public MustOverride Function FindName(ByVal name As String) As CommandBase

    End Class
End Namespace
