﻿Namespace Validation
    Public Class NumericValidationRule
        Inherits WPFGlue.Validation.ValidationRule

        Public Property MaxValue As Nullable(Of Double)
        Public Property MinValue As Nullable(Of Double)
        Public Sub New()
            MyClass.New(Double.MinValue, Double.MaxValue, "Must be number between {1} and {2}")
        End Sub

        Public Sub New(ByVal minValue As Double, ByVal maxValue As Double, ByVal message As String)
            Me.ValidationStep = System.Windows.Controls.ValidationStep.RawProposedValue
            Me.MaxValue = maxValue
            Me.MinValue = minValue
            Me.Message = message
        End Sub

        Protected Overrides Function ValidateCore(ByVal value As Object, ByVal cultureInfo As System.Globalization.CultureInfo) As Boolean
            Dim result As Boolean = IsNumeric(value)
            If result And MinValue.HasValue Then
                result = CDbl(value) >= MinValue
            End If
            If result And MaxValue.HasValue Then
                result = CDbl(value) <= MaxValue
            End If
            Return result
        End Function

        Protected Overrides Function FormatMessage(ByVal value As Object) As String
            Return String.Format(Me.Message, value, MinValue, MaxValue)
        End Function
    End Class
End Namespace
